VERSION 5.00
Begin VB.Form frmParseURLs 
   AutoRedraw      =   -1  'True
   Caption         =   "Parse URLs From A File"
   ClientHeight    =   2940
   ClientLeft      =   2625
   ClientTop       =   1500
   ClientWidth     =   4965
   Icon            =   "frmParseURLs.frx":0000
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   196
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   331
   Begin VB.CommandButton cmdSelectFile 
      Caption         =   "Select File"
      Height          =   360
      Left            =   1830
      TabIndex        =   1
      Top             =   2415
      Width           =   1215
   End
   Begin VB.ListBox lstURLs 
      Height          =   1815
      ItemData        =   "frmParseURLs.frx":000C
      Left            =   45
      List            =   "frmParseURLs.frx":000E
      TabIndex        =   0
      Top             =   300
      Width           =   4875
   End
   Begin VB.Label Label1 
      Caption         =   "URLs In File"
      Height          =   240
      Left            =   60
      TabIndex        =   2
      Top             =   45
      Width           =   1215
   End
End
Attribute VB_Name = "frmParseURLs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to use the ReadFile API function to
  ' read an ASCII text file and parse URLs from the text without
  ' converting the entire file to unicode
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.

  Private Const vbZLString As String = ""
  
  Private Const GENERIC_READ As Long = &H80000000
  Private Const GENERIC_WRITE As Long = &H40000000

  Private Const FILE_SHARE_READ As Long = &H1&
  Private Const FILE_SHARE_WRITE As Long = &H2&

  Private Const CREATE_NEW As Long = 1&
  Private Const CREATE_ALWAYS As Long = 2&
  Private Const OPEN_EXISTING As Long = 3&
  Private Const OPEN_ALWAYS As Long = 4&
  Private Const TRUNCATE_EXISTING As Long = 5&

  Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName$, ByVal dwDesiredAccess&, ByVal dwShareMode&, ByVal lpSecurityAttributes&, ByVal dwCreationDisposition&, ByVal dwFlagsAndAttributes&, ByVal hTemplateFile&) As Long
  Private Declare Function ReadFile Lib "kernel32" (ByVal hFile&, lpBuffer As Any, ByVal nNumberOfBytesToRead&, lpNumberOfBytesRead&, ByVal lpOverlapped&) As Long
  Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject&) As Long
  
  Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)

Private Sub cmdSelectFile_Click()

  Dim sInputName$, nFileLen&, hFile&, nReadRetVal&, nBytesRead&
  Dim aInputFile() As Byte, oGetFile As cGetFileName
  
  ' begin by clearing the list
  lstURLs.Clear
  
  Set oGetFile = New cGetFileName
  
  ' get the input name dynamically instead of hard coding it like this....
  sInputName = oGetFile.GetOpenName(hWnd, App.Path)
  
  Set oGetFile = Nothing
  
  If sInputName <> vbZLString Then
    nFileLen = FileLen(sInputName)
    
    ReDim aInputFile(nFileLen - 1) As Byte '<-- subtract one for zero based array
    
    ' use APIs to open the file and read the data since I find it easier to manipulate byte
    ' arrays using API functions
    hFile = CreateFile(sInputName, GENERIC_READ, FILE_SHARE_READ, 0&, OPEN_EXISTING, 0&, 0&)
    
    If hFile Then ' if we have a valid file handle, get the data
    
      ' pass a pointer to the buffer to ReadFile....
      nReadRetVal = ReadFile(hFile, ByVal VarPtr(aInputFile(0)), nFileLen, nBytesRead, 0&)
    
      Call CloseHandle(hFile)
      
      If (nReadRetVal <> 0) And (nBytesRead > 0) Then
        Dim i&, nFoundLocation&, sSearchString$, nLastURL&, asURL() As String
        Dim bEmbededCrLf As Boolean
        
        nLastURL = (-1) '<-- set up the string array counter so it will point to "0" when incremented the first time
        
        ReDim asURL(0) As String
        
        ' convert the search string to ANSI
        sSearchString = StrConv("http://", vbFromUnicode)
        
        Do ' loop through the file looking for all occurrences of URL strings....
          
          nFoundLocation = InStrB(nFoundLocation + 1, aInputFile, sSearchString)
          
          If nFoundLocation Then
            ' if we found a URL, loop through the byte array from the found location
            ' until we encounter a space
  
            ' reset the var indicating a carriage return was found in the URL
            bEmbededCrLf = False
            
            i = nFoundLocation + 6 '<-- add the length of the search string
            Do
              i = i + 1
              
              If i > nFileLen Then
                ' error!!  DO SOMETHING!!!!
                Exit Do
              End If
              
              Select Case aInputFile(i)
                Case vbKeySpace, 34, 62 ' 34='"'  62='>'
                  Exit Do ' found a space, '"' or '>', get out of the loop
                  
                Case 13 '<-- vbCr
                  ' set the flag so that carriage returns will be removed
                  bEmbededCrLf = True
                  
              End Select
            Loop While i < nFileLen '<-- safety feature
            
            ' increment the string array counter and add a new string to the array
            nLastURL = nLastURL + 1
            ReDim Preserve asURL(nLastURL) As String
            
            ' allocate string space.  divide by two since VB strings are
            ' unicode and we will be copying an ANSI string into the variable
            asURL(nLastURL) = String$((i - (nFoundLocation - 1)) / 2, 0)
            
            ' copy the string from the byte array into the string
            CopyMemory ByVal StrPtr(asURL(nLastURL)), ByVal VarPtr(aInputFile((nFoundLocation - 1))), i - (nFoundLocation - 1)
            
            ' convert the string to unicode
            asURL(nLastURL) = StrConv(asURL(nLastURL), vbUnicode)
            
            ' remove any carriage returns from the string
            If bEmbededCrLf Then asURL(nLastURL) = Replace(asURL(nLastURL), vbCrLf, vbZLString)
            
            ' account for odd length strings
            If Right$(asURL(nLastURL), 1) = vbNullChar Then asURL(nLastURL) = Left$(asURL(nLastURL), Len(asURL(nLastURL)) - 1)
          End If
          
        Loop Until nFoundLocation = 0
        
        
        If nLastURL > (-1) Then
          ' print your array of URLs to the immediate window
          For i = 0 To nLastURL
            lstURLs.AddItem asURL(i)
          Next
        Else
          lstURLs.AddItem "No URLs Found"
        End If
        
      End If
    End If
  End If
  
End Sub

Public Function Replace(ByVal sText$, ByVal sToReplace$, ByVal sReplaceWith$) As String

  Dim nRepLoc&
  
  Do
    nRepLoc = InStr(sText, sToReplace)
    
    If nRepLoc Then sText = Left$(sText, nRepLoc - 1) & sReplaceWith & Right$(sText, Len(sText) - ((nRepLoc - 1) + Len(sToReplace)))
  Loop Until nRepLoc = 0
  
  Replace = sText
  
End Function

